
/// <reference path="../lib/SpreadJS/definition/gcspread.sheets.d.ts"/>

//http://www.jqueryrain.com/?zETM2MpT

declare var $;

class ColorPickerCellType extends GcSpread.Sheets.CustomCellType {


    createEditorElement(context) {
        //Create input presenter.
        return document.createElement("input");
    }

    activateEditor(editorContext: any, cellStyle: GcSpread.Sheets.Style, cellRect: GcSpread.Sheets.Rect, context?: any) {
        var $editor = $(editorContext);
        super.activateEditor(editorContext, cellStyle, cellRect, context);
        $editor.css("position", "absolute");
        $editor.colorpicker();
        $editor.attr("gcUIElement", "gcEditingInput");
        $(".colorpicker").attr("gcUIElement", "gcEditingInput");
    }

    deactivateEditor(editorContext: any, context?: any) {
        if (editorContext) {
            var $editor = $(editorContext);
            $editor.colorpicker("hide");
            $editor.colorpicker("destroy");
        }

        super.deactivateEditor(editorContext, context);
    }

    setEditorValue(editorContext: any, value: any, context?: any) {
        $(editorContext).colorpicker("setValue", value);
    }

    getEditorValue(editorContext: any, context?: any) {
        return $(editorContext).colorpicker("getValue");
    }

    updateEditor(editorContext: any, cellStyle: GcSpread.Sheets.Style, cellRect: GcSpread.Sheets.Rect, context?: any) {
        if (editorContext) {
            var $editor = $(editorContext);
            $editor.css("width", cellRect.width);
            $editor.css("height", cellRect.height);
        }
    }

    paint(ctx: CanvasRenderingContext2D, value: any, x: number, y: number, width: number, height: number, style: GcSpread.Sheets.Style, context?: any) {

        if (value) {
            ctx.fillStyle = value;
            ctx.fillRect(x, y, width, height);
            ctx.fillStyle = "#FFFFFF";
            super.paint(ctx, value, x, y, width, height, style, context);
        }
        else {
            super.paint(ctx, value, x, y, width, height, style, context);
        }
    }




}